# $Id: chameleon.m4,v 1.6 2003/01/24 09:14:31 aquamaniac Exp $
# (c) 2002 Martin Preuss<martin@libchipcard.de>
# This function checks for libchameleon


AC_DEFUN(AQ_CHAMELEON_INCLUDED,[
dnl PREREQUISITES:
dnl   - AQ_CHECK_OS must already have been called
dnl   - AC_CHECK_HEADER(syslog.h) must have been called
dnl IN: 
dnl   - path and name of Chameleon (e.g. src/libchipcard/chameleon)
dnl OUT:
dnl   Variables:
dnl     chameleon_needed_libs: libraries libchameleon needs (subst)
dnl     chameleon_includes:    CFLAGS for chameleon includes (subst)
dnl     chameleon_libs:        LDADD/LIBADD instructions for chameleon (subst)

AC_MSG_CHECKING(for chameleon)
case "$OS_TYPE" in
 windows)
  chameleon_needed_libs="-L/c/windows -lwsock32"
  cp $1/windows/*.c $1/
  cp $1/windows/*.h $1/
  ;;
 posix)
  cp $1/posix/*.c $1/
  cp $1/posix/*.h $1/
  ;;
esac
AC_SUBST(chameleon_needed_libs)
chameleon_includes="-I$top_srcdir/$1"
chameleon_libs="\${top_srcdir}/$1/libchameleon.la"
AC_SUBST(chameleon_includes)
AC_SUBST(chameleon_libs)

AC_MSG_RESULT(ok)
])

