/***************************************************************************
 $RCSfile: readerserver.h,v $
 -------------------
 cvs         : $Id: readerserver.h,v 1.2 2003/02/17 04:17:46 aquamaniac Exp $
 begin       : Sat Jan 11 2003
 copyright   : (C) 2003 by Martin Preuss
 email       : martin@libchipcard.de

 ***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU Lesser General Public            *
 *   License as published by the Free Software Foundation; either          *
 *   version 2.1 of the License, or (at your option) any later version.    *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *   Lesser General Public License for more details.                       *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston,                 *
 *   MA  02111-1307  USA                                                   *
 *                                                                         *
 ***************************************************************************/



#ifndef READERSERVER_H
#define READERSERVER_H "$Id: readerserver.h,v 1.2 2003/02/17 04:17:46 aquamaniac Exp $"

#include <ctcore.h>
#include <ctserver.h>
#include <chameleon/conf.h>


#ifdef __cplusplus
extern "C" {
#endif

typedef struct READERSERVERWAITSTRUCT READERSERVERWAITDATA;

struct READERSERVERWAITSTRUCT {
  READERSERVERWAITDATA *next;
  int msgLayerId;
  int requestId;
  char *typeName;
  unsigned int readerFlags;
  unsigned int readerFlagsMask;
  unsigned int readerStatus;
  unsigned int readerStatusMask;
};


READERSERVERWAITDATA *ReaderServer__WaitRequest_new();
void ReaderServer_WaitRequest__free(READERSERVERWAITDATA *wr);


struct READERSERVERDATASTRUCT {
  CTCORETABLE *core;
  int coreClientId;
  READERSERVERWAITDATA *waitRequests;
};
typedef struct READERSERVERDATASTRUCT READERSERVERDATA;


READERSERVERDATA *ReaderServer_new();
void ReaderServer_free(READERSERVERDATA *rsd);

ERRORCODE ReaderServer_Init(CTSERVERDATA *sd, CONFIGGROUP *root);
ERRORCODE ReaderServer_Fini(CTSERVERDATA *sd);

ERRORCODE ReaderServer_AddReader(CTSERVERDATA *sd, CTREADERDESCRIPTION *rd);
ERRORCODE ReaderServer_CheckWaitResponses(CTSERVERDATA *sd,
					  int mustChange);
ERRORCODE ReaderServer_Work(CTSERVERDATA *sd,
			    int timeout,
			    int maxmsg);


#ifdef __cplusplus
}
#endif


#endif

