/***************************************************************************
 $RCSfile: ctclient.h,v $
 -------------------
 cvs         : $Id: ctclient.h,v 1.11 2003/02/17 13:52:46 aquamaniac Exp $
 begin       : Fri Nov 29 2002
 copyright   : (C) 2002 by Martin Preuss
 email       : martin@libchipcard.de

 ***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU Lesser General Public            *
 *   License as published by the Free Software Foundation; either          *
 *   version 2.1 of the License, or (at your option) any later version.    *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *   Lesser General Public License for more details.                       *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston,                 *
 *   MA  02111-1307  USA                                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef CTCLIENT_H
#define CTCLIENT_H


#ifdef __cplusplus
extern "C" {
#endif


#include <ctservice.h>
#include <chameleon/ipcservicelayer.h>

typedef struct CTCLIENT_STRINGLISTENTRYSTRUCT CTCLIENT_STRINGLISTENTRY;
struct CTCLIENT_STRINGLISTENTRYSTRUCT {
  CTCLIENT_STRINGLISTENTRY *next;
  char *data;
};

CTCLIENT_STRINGLISTENTRY *CTClient_StringListEntry_new();
/*
void CTClient_StringListEntry_free(CTCLIENT_STRINGLISTENTRY *sl);
void CTClient_StringListEntry_Append(CTCLIENT_STRINGLISTENTRY *sl,
				     CTCLIENT_STRINGLISTENTRY **head);
void CTClient_StringListEntry_Remove(CTCLIENT_STRINGLISTENTRY *sl,
				     CTCLIENT_STRINGLISTENTRY **head);
*/

struct CTCLIENT_READERDESCRSTRUCT {
  unsigned int flags;
  char name[64];
  char type[64];
};
typedef struct CTCLIENT_READERDESCRSTRUCT CTCLIENT_READERDESCR;


struct CTCLIENTDATASTRUCT {
  IPCSERVICELAYER *service;
  char *clientIdString;
  int nextPeerId;
  int nextMessageId;
};
typedef struct CTCLIENTDATASTRUCT CTCLIENTDATA;


CTCLIENTDATA *CTClient_new();
void CTClient_free(CTCLIENTDATA *cd);

CTCLIENT_READERDESCR *CTClient_ReaderDescr_new();
void CTClient_ReaderDescr_free(CTCLIENT_READERDESCR *rd);


ERRORCODE CTClient_Init(CTCLIENTDATA *cd);
ERRORCODE CTClient_Fini(CTCLIENTDATA *cd);

/**
 * @param port port the server is listening on. If "-1" then unix domain
 * sockets are used, in this case the address should be the path to the
 * socket file.
 */
ERRORCODE CTClient_AddServer(CTCLIENTDATA *cd,
			     const char *addr,
			     int port);
void CTClient_SetClientIdString(CTCLIENTDATA *cd,
				const char *cid);

ERRORCODE CTClient_CheckErrorMessage(CTCLIENTDATA *cd,
				     IPCMESSAGE *msg);

ERRORCODE CTClient_Work(CTCLIENTDATA *cd,
			int timeout,
			int maxmsg);

ERRORCODE CTClient_SendRequest(CTCLIENTDATA *cd,
			       CTSERVICEREQUEST *req,
			       int id);

ERRORCODE CTClient_CheckResponse(CTCLIENTDATA *cd,
				 int requestid);

void CTClient_WithdrawRequest(CTCLIENTDATA *cd,
			      int requestid);
CTSERVICEREQUEST *CTClient_FindRequest(CTCLIENTDATA *cd,
				       int requestid);
void CTClient_DequeueRequest(CTCLIENTDATA *cd,
			     CTSERVICEREQUEST *req);


#ifdef __cplusplus
}
#endif


#endif



